package Applets.Math.Coordinates;

import java.awt.BorderLayout;
import java.awt.CheckboxGroup;
import java.awt.Choice;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Image;
import java.awt.Insets;
import java.awt.Label;
import java.awt.Panel;
import java.awt.Point;
import java.awt.Polygon;
import java.awt.Scrollbar;
import java.awt.Window;
import java.awt.event.AdjustmentEvent;
import java.awt.event.AdjustmentListener;
import java.awt.event.InputEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.EventObject;

class SphCoordFrm extends Frame
  implements AdjustmentListener, ItemListener, MouseListener, WindowListener, MouseMotionListener
{
  Dimension od;
  Image oi;
  Graphics og;
  Point point;
  Point p0;
  Polygon poly;
  final double omega = -0.015707963267948967D;
  int ox = 300;
  int oy = 250;
  int cv;
  double theta = 0.52359877559829882D;
  double phi = 2.0943951023931953D;
  double angx = 1.0471975511965976D;
  double angz = -0.39269908169872414D;
  double c1;
  double c2;
  double c3;
  double c4;
  double c5;
  double c6;
  double c7;
  double c8;
  double lat;
  double lng;
  double r = 15.0D;
  int delay = 40;
  int prevx;
  int prevy;
  int frame;
  boolean running;
  boolean painted;
  final Color biege;
  final Color brown;
  CheckboxGroup cbgAnim;
  CheckboxGroup cbgDisp;
  Choice chDisplay;
  Font fontH;
  Font fontL;
  Panel CtrlPnl;
  Label labRadius;
  Label labLong;
  Label labLat;
  Scrollbar sbLat;
  Scrollbar sbLong;
  Scrollbar sbRadius;

  public SphCoordFrm()
  {
    this.frame = (int)(100.0D * this.angz);

    this.running = false;
    this.biege = new Color(16770244);
    this.brown = new Color(11837587);

    super.setTitle("Coordenadas Polares");
    this.point = new Point();
    this.p0 = new Point(this.ox, this.oy);
    setLayout(new BorderLayout());
    setBackground(Color.black);
    this.CtrlPnl = new Panel();
    this.CtrlPnl.setBackground(this.biege);
    this.fontH = new Font("Helvetica", 1, 12);
    setFont(this.fontH);
    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints constraints = new GridBagConstraints();
    this.CtrlPnl.setLayout(gridbag);
    constraints.fill = 0;

    buildConstraints(constraints, 0, 0, 1, 2, 5, 10, 4, 4, 4, 4);
    this.chDisplay = new Choice();
    this.chDisplay.add("   Um Ponto ");
    this.chDisplay.add("   Area elementar - 1 ");
    this.chDisplay.add("   Area elementar - 2 ");
    this.chDisplay.add("   Zona elementar  ");
    this.chDisplay.select(0);
    this.chDisplay.setBackground(Color.white);
    this.chDisplay.addItemListener(this);
    gridbag.setConstraints(this.chDisplay, constraints);
    this.CtrlPnl.add(this.chDisplay);

    constraints.fill = 1;
    buildConstraints(constraints, 1, 0, 1, 1, 5, 10, 4, 2, 1, 2);
    this.labRadius = new Label("Raio", 1);
    gridbag.setConstraints(this.labRadius, constraints);
    this.CtrlPnl.add(this.labRadius);

    buildConstraints(constraints, 1, 1, 1, 1, 5, 10, 1, 2, 4, 2);
    this.sbRadius = new Scrollbar(0, 15, 1, 10, 20);
    gridbag.setConstraints(this.sbRadius, constraints);
    this.sbRadius.addAdjustmentListener(this);
    this.CtrlPnl.add(this.sbRadius);

    buildConstraints(constraints, 2, 0, 1, 1, 5, 10, 4, 2, 1, 2);
    this.labLong = new Label("Fi", 1);
    this.labLong.setEnabled(false);

    gridbag.setConstraints(this.labLong, constraints);
    this.CtrlPnl.add(this.labLong);

    buildConstraints(constraints, 2, 1, 1, 1, 5, 10, 1, 2, 4, 2);
    this.sbLong = new Scrollbar(0, 0, 1, 0, 11);
    this.sbLong.setEnabled(false);
    gridbag.setConstraints(this.sbLong, constraints);
    this.sbLong.addAdjustmentListener(this);
    this.CtrlPnl.add(this.sbLong);

    buildConstraints(constraints, 3, 0, 1, 1, 5, 10, 4, 2, 1, 50);
    this.labLat = new Label("Teta", 1);
    this.labLat.setEnabled(false);
    gridbag.setConstraints(this.labLat, constraints);
    this.CtrlPnl.add(this.labLat);

    buildConstraints(constraints, 3, 1, 1, 1, 5, 10, 1, 2, 4, 50);
    this.sbLat = new Scrollbar(0, 1, 1, 1, 12);
    this.sbLat.setEnabled(false);
    gridbag.setConstraints(this.sbLat, constraints);
    this.sbLat.addAdjustmentListener(this);
    this.CtrlPnl.add(this.sbLat);

    add("South", this.CtrlPnl);
    calcCoeff();
    addMouseListener(this);
    addMouseMotionListener(this);
    repaint();
    addWindowListener(this);
  }

  void buildConstraints(GridBagConstraints gbc, int gx, int gy, int gw, int gh, int wx, int wy, int top, int left, int bottom, int right)
  {
    gbc.gridx = gx;
    gbc.gridy = gy;
    gbc.gridwidth = gw;
    gbc.gridheight = gh;
    gbc.weightx = wx;
    gbc.weighty = wy;
    gbc.insets = new Insets(top, left, bottom, right);
  }

  void buildConstraints(GridBagConstraints gbc, int gx, int gy, int gw, int gh, int wx, int wy, int left, int right)
  {
    gbc.gridx = gx;
    gbc.gridy = gy;
    gbc.gridwidth = gw;
    gbc.gridheight = gh;
    gbc.weightx = wx;
    gbc.weighty = wy;
    gbc.insets = new Insets(2, left, 2, right);
  }

  public void adjustmentValueChanged(AdjustmentEvent ae) {
    if (ae.getSource() == this.sbRadius)
      this.r = this.sbRadius.getValue();

    if (ae.getSource() == this.sbLat)
      this.lat = (0.25D - 0.050000000000000003D * this.sbLat.getValue());

    if (ae.getSource() == this.sbLong)
      this.lng = (-0.25D + 0.050000000000000003D * this.sbLong.getValue());

    repaint();
  }

  public void itemStateChanged(ItemEvent e) {
    if (e.getItemSelectable() == this.chDisplay) {
      this.cv = this.chDisplay.getSelectedIndex();
      switch (this.cv)
      {
      case 0:
        this.labRadius.setEnabled(true);
        this.labLong.setEnabled(true);
        this.labLat.setEnabled(true);
        this.sbRadius.setEnabled(true);
        this.sbLong.setEnabled(true);
        this.sbLat.setEnabled(true);
        this.sbLat.setMaximum(10);
        this.sbLat.setMinimum(0);
        this.sbLong.setMaximum(10);
        break;
      case 1:
        this.labLong.setEnabled(false);
        this.labLat.setEnabled(false);
        this.sbLong.setEnabled(false);
        this.sbLat.setEnabled(false);
        break;
      case 2:
        this.labLong.setEnabled(false);
        this.labLat.setEnabled(false);
        this.sbLong.setEnabled(false);
        this.sbLat.setEnabled(false);
        break;
      case 3:
        this.labRadius.setEnabled(true);
        this.labLong.setEnabled(true);
        this.labLat.setEnabled(true);
        this.sbRadius.setEnabled(true);
        this.sbLong.setEnabled(true);
        this.sbLat.setEnabled(true);
        this.sbLat.setMaximum(9);
        this.sbLat.setMinimum(1);
        this.sbLong.setMaximum(8);
      }

      repaint();
    }
  }

  public void mouseClicked(MouseEvent e) {
  }

  public void mousePressed(MouseEvent e) {
    requestFocus();
    this.prevx = e.getX();
    this.prevy = e.getY();
    e.consume(); }

  public void mouseReleased(MouseEvent e) { }

  public void mouseEntered(MouseEvent e) { }

  public void mouseExited(MouseEvent e) {  }

  public void mouseDragged(MouseEvent e) { int x = e.getX();
    int y = e.getY();
    double alp = (y - this.prevy) * 0.35999999999999999D / getSize().height;
    double bet = (this.prevx - x) * 0.35999999999999999D / getSize().width;
    this.angz += bet * 57.295779500000002D; this.frame = (int)(100.0D * this.angz);
    this.angx += alp * 57.295779500000002D; this.theta = this.angx;
    if (this.angx > 1.5707963267948966D) this.angx = 1.5707963267948966D;
    if (this.angx < 0D) this.angx = 0D;
    this.frame += this.prevx - x;
    calcCoeff();
    if (this.painted) {
      this.painted = false; repaint();
    }
    this.prevx = x;
    this.prevy = y;
    e.consume(); }

  public void mouseMoved(MouseEvent e) {
  }

  public void update(Graphics g) {
    Dimension d = getSize();
    if ((this.og == null) || 
      (d.width != this.od.width) || 
      (d.height != this.od.height)) {
      this.od = d;
      this.oi = createImage(d.width, d.height);
      this.og = this.oi.getGraphics();
      this.ox = (d.width / 2);
      this.oy = (d.height / 2);
      calcCoeff();
      repaint();
    }

    this.og.setColor(getBackground());
    this.og.fillRect(0, 0, d.width, d.height);
    this.og.setColor(Color.black);
    paintFrame(this.og);
    g.drawImage(this.oi, 0, 0, null);
  }

  public void paint(Graphics g) {
    if (this.oi != null)
      g.drawImage(this.oi, 0, 0, null);

    repaint();
  }

  void calcCoeff() {
    this.c1 = Math.cos(this.angz);
    this.c2 = Math.sin(this.angz);
    this.c3 = Math.cos(this.angx);
    this.c4 = Math.sin(this.angx);
    this.c5 = (this.c1 * this.c3);
    this.c6 = (this.c1 * this.c4);
    this.c7 = (this.c2 * this.c3);
    this.c8 = (this.c2 * this.c4);
  }

  Point transform(double x, double y, double z) {
    double xs = this.c1 * x - this.c2 * y;
    double ys = this.c7 * x + this.c5 * y + this.c4 * z;
    double zs = this.c8 * x + this.c6 * y - this.c3 * z;
    double d = 100.0D; double D = 150.0D;

    xs = 15.0D * xs * d / (zs + D);
    ys = 15.0D * ys * d / (zs + D);
    return new Point((int)(this.ox + xs + 0.5D), (int)(this.oy - ys + 0.5D));
  }

  public void drawArrow(Graphics g, Point p1, Point p2)
  {
    double theta = Math.atan2(p1.y - p2.y, p2.x - p1.x);
    theta = Math.round(theta * 57.272727000000003D) / 57.272727000000003D;
    g.drawLine(p1.x, p1.y, p2.x, p2.y);
    g.drawLine(p1.x + 1, p1.y, p2.x + 1, p2.y);
    g.drawLine(p1.x, p1.y + 1, p2.x, p2.y + 1);
    long x = Math.round(8.0D * Math.cos(theta + 0.31415926535897931D));
    long y = Math.round(8.0D * Math.sin(theta + 0.31415926535897931D));
    g.drawLine(p2.x, p2.y, p2.x - (int)x, p2.y + (int)y);
    g.drawLine(p2.x + 1, p2.y, p2.x + 1 - (int)x, p2.y + (int)y);
    g.drawLine(p2.x, p2.y + 1, p2.x - (int)x, p2.y + 1 + (int)y);
    x = Math.round(8.0D * Math.cos(theta - 0.31415926535897931D));
    y = Math.round(8.0D * Math.sin(theta - 0.31415926535897931D));
    g.drawLine(p2.x, p2.y, p2.x - (int)x, p2.y + (int)y);
    g.drawLine(p2.x + 1, p2.y, p2.x + 1 - (int)x, p2.y + (int)y);
    g.drawLine(p2.x, p2.y + 1, p2.x - (int)x, p2.y + 1 + (int)y);
  }

  void thickLine(Graphics g, Point p1, Point p2) {
    g.drawLine(p1.x + 1, p1.y, p2.x + 1, p2.y);
    g.drawLine(p1.x, p1.y, p2.x, p2.y);
    g.drawLine(p1.x, p1.y + 1, p2.x, p2.y + 1);
    g.drawLine(p1.x + 1, p1.y + 1, p2.x + 1, p2.y + 1);
  }

  public void drawAxes(Graphics g) {
    g.setColor(Color.white.darker());

    Point p0 = transform(0D, -25.0D, 0D);
    Point p1 = transform(0D, 25.0D, 0D);
    Point p2 = transform(0D, -26.0D, 0D);
    drawArrow(g, p1, p0);
    g.drawString("X", p2.x, p2.y);
    p0 = transform(-25.0D, 0D, 0D);
    p1 = transform(25.0D, 0D, 0D);
    p2 = transform(26.0D, 0D, 0D);
    drawArrow(g, p0, p1);
    g.drawString("Y", p2.x, p2.y);
    p0 = transform(0D, 0D, 0D);
    if (this.cv == 2) p0 = transform(0D, 0D, 0D);
    p1 = transform(0D, 0D, 22.0D);
    p2 = transform(0D, 0D, 23.0D);
    drawArrow(g, p0, p1);
    g.drawString("Z", p2.x, p2.y);
  }

  void drawLat(Graphics g, double phi)
  {
    double theta = 0.062831853071795868D;

    phi *= 3.1415926535897931D;
    Point pp = transform(this.r * Math.sin(phi), 0D, this.r * Math.cos(phi));
    for (int i = 0; i >= -25; --i) {
      double cos = Math.cos(theta * i); double sin = Math.sin(theta * i);
      double x = this.r * cos * Math.sin(phi);
      double y = this.r * sin * Math.sin(phi);
      double z = this.r * Math.cos(phi);
      Point CtrlPnl = transform(x, y, z);
      g.setColor(Color.cyan);
      thickLine(g, pp, CtrlPnl);
      pp = CtrlPnl;
    }
  }

  void drawLong(Graphics g, double theta) {
    double phi = 0.062831853071795868D;
    theta *= 3.1415926535897931D;
    Point pp = transform(0D, 0D, this.r);
    double cos = Math.cos(theta); double sin = Math.sin(theta);
    for (int i = 0; i <= 25; ++i) {
      double x = this.r * cos * Math.sin(phi * i);
      double y = this.r * sin * Math.sin(phi * i);
      double z = this.r * Math.cos(phi * i);
      Point CtrlPnl = transform(x, y, z);
      g.setColor(Color.yellow);
      thickLine(g, pp, CtrlPnl);
      pp = CtrlPnl;
    }
  }

  void drawLines(Graphics g)
  {
    Point p0 = transform(0D, 0D, 0D);
    double ang = 0.25D;
    if (this.cv == 3) ang = 0.29999999999999999D;
    double ang1 = (0.25D + this.lat) * 3.1415926535897931D; double ang2 = -(this.lng + ang) * 3.1415926535897931D;
    double x = -this.r * Math.cos(ang1) * Math.sin(ang2);
    double y = this.r * Math.sin(ang1) * Math.sin(ang2);
    double z = this.r * Math.cos(ang2);
    Point p1 = transform(x, y, z); Point p2 = transform(x, y, 0D);
    g.setColor(Color.blue);
    thickLine(g, p0, p1);
    g.setColor(Color.green);
    thickLine(g, p1, p2);
    g.setColor(Color.red);
    thickLine(g, p0, p2);
    Point p3 = transform(x, 0D, 0D);
    Point p4 = transform(0D, y, 0D);
    g.setColor(Color.orange);
    thickLine(g, p2, p4);
    g.setColor(Color.pink);
    thickLine(g, p2, p3);
  }

  void drawLongArc(Graphics g, double theta)
  {
    g.setColor(Color.yellow);
    int sp = 0;
    theta *= 3.1415926535897931D;
    double phi = 0.062831853071795868D;
    double cos = this.r * Math.cos(theta); double sin = this.r * Math.sin(theta);
    Point pp = transform(cos * Math.sin(phi * sp), sin * Math.sin(phi * sp), this.r * Math.cos(phi * sp));
    Point ppz = transform(0D, 0D, this.r * Math.cos(phi * sp));
    Point po = transform(0D, 0D, 0D);
    thickLine(g, pp, ppz);
    for (int i = sp; i <= 25; ++i) {
      double x = cos * Math.sin(phi * i);
      double y = sin * Math.sin(phi * i);
      double z = this.r * Math.cos(phi * i);
      Point CtrlPnl = transform(x, y, z);
      thickLine(g, pp, CtrlPnl);
      pp = CtrlPnl;
      if (i == 25) thickLine(g, pp, po);
      if ((i == 12) || (i == 15)) thickLine(g, pp, po);
    }
  }

  void drawLongArc(Graphics g, double theta, int sp, int ep, boolean lines) {
    g.setColor(Color.yellow);
    theta *= 3.1415926535897931D;
    double phi = 0.062831853071795868D;
    double cos = this.r * Math.cos(theta); double sin = this.r * Math.sin(theta);
    Point pp = transform(cos * Math.sin(phi * sp), sin * Math.sin(phi * sp), this.r * Math.cos(phi * sp));
    Point ppz = transform(0D, 0D, this.r * Math.cos(phi * sp));
    Point po = transform(0D, 0D, 0D);
    thickLine(g, pp, ppz);
    for (int i = sp; i <= ep; ++i) {
      double x = cos * Math.sin(phi * i);
      double y = sin * Math.sin(phi * i);
      double z = this.r * Math.cos(phi * i);
      Point CtrlPnl = transform(x, y, z);
      thickLine(g, pp, CtrlPnl);
      pp = CtrlPnl;
      if (i == 25) thickLine(g, pp, po);
      if ((lines) && (((i == sp) || (i == ep) || (i == 15)))) thickLine(g, pp, po);
    }
  }

  void drawLatArc(Graphics g, double phi)
  {
    g.setColor(Color.cyan);
    int sp = 10;
    phi *= 3.1415926535897931D;
    double theta = -0.062831853071795868D;
    double cos = this.r * Math.cos(phi); double sin = this.r * Math.sin(phi);
    Point pp = transform(sin * Math.cos(theta * sp), sin * Math.sin(theta * sp), cos);
    Point ppz = transform(0D, 0D, cos);
    for (int i = sp; i <= 15; ++i) {
      double x = sin * Math.cos(theta * i);
      double y = sin * Math.sin(theta * i);
      double z = cos;
      Point CtrlPnl = transform(x, y, z);
      thickLine(g, pp, CtrlPnl);
      pp = CtrlPnl;
      if ((i == sp) || (i == 15)) thickLine(g, pp, ppz);
    }
  }

  void drawLatArc(Graphics g, double phi, int sp, int ep, boolean lines) {
    g.setColor(Color.cyan);
    phi *= 3.1415926535897931D;
    double theta = -0.062831853071795868D;
    double cos = this.r * Math.cos(phi); double sin = this.r * Math.sin(phi);
    Point pp = transform(sin * Math.cos(theta * sp), sin * Math.sin(theta * sp), cos);
    Point ppz = transform(0D, 0D, cos);
    for (int i = sp; i <= ep; ++i) {
      double x = sin * Math.cos(theta * i);
      double y = sin * Math.sin(theta * i);
      double z = cos;
      Point CtrlPnl = transform(x, y, z);
      thickLine(g, pp, CtrlPnl);
      pp = CtrlPnl;
      if ((lines) && (((i == sp) || (i == ep)))) thickLine(g, pp, ppz);
    }
  }

  void drawAreaElement(Graphics g, double c1, double c2)
  {
    g.setColor(Color.white);
    Polygon poly = new Polygon();

    double phi = c1 * 3.1415926535897931D;
    double theta = -c2 * 3.1415926535897931D;
    double cos = this.r * Math.cos(phi);
    double sin = this.r * Math.sin(phi);
    Point CtrlPnl = transform(sin * Math.cos(theta), sin * Math.sin(theta), cos);
    poly.addPoint(CtrlPnl.x, CtrlPnl.y);
    phi = (c1 + 0.02D) * 3.1415926535897931D;
    theta = -c2 * 3.1415926535897931D;
    cos = this.r * Math.cos(phi);
    sin = this.r * Math.sin(phi);
    CtrlPnl = transform(sin * Math.cos(theta), sin * Math.sin(theta), cos);
    poly.addPoint(CtrlPnl.x, CtrlPnl.y);
    phi = (c1 + 0.02D) * 3.1415926535897931D;
    theta = -(c2 + 0.02D) * 3.1415926535897931D;
    cos = this.r * Math.cos(phi);
    sin = this.r * Math.sin(phi);
    CtrlPnl = transform(sin * Math.cos(theta), sin * Math.sin(theta), cos);
    poly.addPoint(CtrlPnl.x, CtrlPnl.y);
    phi = c1 * 3.1415926535897931D;
    theta = -(c2 + 0.02D) * 3.1415926535897931D;
    cos = this.r * Math.cos(phi);
    sin = this.r * Math.sin(phi);
    CtrlPnl = transform(sin * Math.cos(theta), sin * Math.sin(theta), cos);
    poly.addPoint(CtrlPnl.x, CtrlPnl.y);
    g.fillPolygon(poly);
  }

  void drawPlane(Graphics g)
  {
    g.setColor(Color.gray);
    Polygon poly = new Polygon();
    Point p1 = transform(25.0D, 25.0D, 0D);
    Point p2 = transform(-25.0D, -25.0D, 0D);
    Point p3 = transform(25.0D, -25.0D, 0D);
    Point p4 = transform(-25.0D, 25.0D, 0D);
    poly.addPoint(p1.x, p1.y);
    poly.addPoint(p3.x, p3.y);
    poly.addPoint(p2.x, p2.y);
    poly.addPoint(p4.x, p4.y);
    g.fillPolygon(poly);
  }

  public void paintFrame(Graphics g)
  {
    drawPlane(g);
    drawAxes(g);
    if (this.cv == 0) {
      drawLong(g, 0D);
      drawLong(g, -0.25D - this.lat);
      drawLong(g, -0.5D);
      drawLat(g, 0.5D);
      drawLat(g, 0.25D + this.lng);
      drawLines(g);
    }
    if (this.cv == 1) {
      drawLongArc(g, -0.29999999999999999D, 10, 25, true);
      drawLongArc(g, -0.20000000000000001D, 10, 25, true);
      drawLatArc(g, 0.20000000000000001D);
      drawLatArc(g, 0.29999999999999999D, 10, 15, false);
      drawLatArc(g, 0.5D);
    }
    if (this.cv == 2) {
      drawLongArc(g, -0.29999999999999999D, 10, 25, true);
      drawLongArc(g, -0.20000000000000001D, 10, 25, false);
      drawLatArc(g, 0.29999999999999999D, 10, 15, false);
      drawLatArc(g, 0.20000000000000001D, 10, 15, true);
      drawLatArc(g, 0.5D, 10, 15, true);
    }
    if (this.cv == 3) {
      drawLines(g);
      drawLong(g, -0.5D);
      drawLong(g, -0.23999999999999999D - this.lat);
      drawLong(g, -0.26000000000000001D - this.lat);
      drawLong(g, 0D);
      drawLat(g, 0.28999999999999998D + this.lng);
      drawLat(g, 0.31D + this.lng);
      drawLat(g, 0.5D);
      drawAreaElement(g, 0.28999999999999998D + this.lng, 0.23999999999999999D + this.lat);
    }
    this.painted = true;
  }

  public void windowActivated(WindowEvent windowEvent) {
  }

  public void windowClosed(WindowEvent windowEvent) {
  }

  public void windowClosing(WindowEvent windowEvent) {
    super.dispose();
  }

  public void windowDeactivated(WindowEvent windowEvent)
  {
  }

  public void windowDeiconified(WindowEvent windowEvent)
  {
  }

  public void windowIconified(WindowEvent windowEvent)
  {
  }

  public void windowOpened(WindowEvent windowEvent)
  {
  }
}
